# Payment Initiation

Universal payment initiation endpoint used by multiple payment types

## Initiate Payment

> Universal payment initiation endpoint used by multiple payment methods.\
> The payment method is determined by the sourceOfFunds.type field.\
> \
> Supported payment types:\
> \- finpaycode: Finpay Payment Code\
> \- dana: DANA E-Money\
> \- finpaymoney: Finpay Money\
> \- jenius: Jenius Pay\
> \- linkajaapplink: LinkAja App Link\
> \- linkajaweb: LinkAja Web\
> \- ovo: OVO E-Money\
> \- shopeepay: ShopeePay E-Money\
> \- virgo: Virgo E-Money\
> \- qris: QRIS Payment\
> \- cc: Credit Card\
> \- bcaklikpay: BCA KlikPay\
> \- bsecure: BSecure\
> \- octoclicks: Octo Clicks\
> \- permatanet: PermataNet\
> \- kredivo: Kredivo Paylater\
> \- indodana: Indodana Paylater\
> \- shopeepaylater: ShopeePay Later<br>

```json
{"openapi":"3.0.3","info":{"title":"Finpay Payment Gateway API","version":"1.0.0"},"tags":[{"name":"Payment Initiation","description":"Universal payment initiation endpoint used by multiple payment types"}],"servers":[{"url":"https://devo.finnet.co.id","description":"Development Server"},{"url":"https://live.finnet.co.id","description":"Production Server"}],"security":[{"BasicAuth":[]}],"components":{"securitySchemes":{"BasicAuth":{"type":"http","scheme":"basic","description":"Basic authentication using Merchant ID and Merchant Key"}},"schemas":{"FinpayPaycodeRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"$ref":"#/components/schemas/SourceOfFunds"}}},"CustomerInfo":{"type":"object","properties":{"id":{"type":"string","description":"Customer ID"},"email":{"type":"string","format":"email","description":"Customer email"},"firstName":{"type":"string","description":"Customer first name"},"lastName":{"type":"string","description":"Customer last name"},"mobilePhone":{"type":"string","description":"Customer mobile phone"}}},"OrderInfo":{"type":"object","properties":{"id":{"type":"string","description":"Order ID"},"amount":{"type":"string","description":"Transaction amount"},"currency":{"type":"string","description":"Currency code"},"description":{"type":"string","description":"Order description"},"item":{"type":"array","items":{"type":"object","properties":{"name":{"type":"string"},"quantity":{"type":"string"},"category":{"type":"string"},"description":{"type":"string"},"unitPrice":{"type":"string"}}}}}},"UrlInfo":{"type":"object","properties":{"callbackUrl":{"type":"string","format":"uri","description":"Callback URL"},"successUrl":{"type":"string","format":"uri","description":"Success URL"},"failUrl":{"type":"string","format":"uri","description":"Failure URL"}}},"SourceOfFunds":{"type":"object","properties":{"type":{"type":"string","description":"Payment method type"},"paymentCode":{"type":"string","description":"Payment code for VA operations"}}},"DANAPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"QRISPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"CardPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"BCAKlikPayPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"IndodanaPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"FinpayMoneyPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"JeniusPayPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"LinkAjaAppLinkPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"LinkAjaWebPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"OVOPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"ShopeePayPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"VirgoPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"BSecurePaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"OctoClicksPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"PermataNetPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"KredivoPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"ShopeePaylaterPaymentRequest":{"type":"object","properties":{"customer":{"$ref":"#/components/schemas/CustomerInfo"},"order":{"$ref":"#/components/schemas/OrderInfo"},"url":{"$ref":"#/components/schemas/UrlInfo"},"sourceOfFunds":{"type":"object","properties":{"type":{"type":"string"}}}}},"FinpayPaycodeResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"StandardResponse":{"type":"object","properties":{"responseCode":{"type":"string","description":"Response code"},"responseMessage":{"type":"string","description":"Response message"},"processingTime":{"type":"number","description":"Processing time in seconds"}}},"DANAPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for DANA payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","nullable":true,"description":"Payment code (null for DANA)"}}}]},"QRISPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for QRIS payment"},"appurl":{"type":"string","description":"App URL for QRIS payment"},"imageurl":{"type":"string","description":"Image URL for QR code"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Payment code (empty for QRIS)"},"stringQr":{"type":"string","description":"QR code string"}}}]},"CardPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for credit card payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"}}}]},"BCAKlikPayPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for BCA KlikPay payment"},"appurl":{"type":"string","description":"App URL for payment"},"imageurl":{"type":"string","description":"Image URL for payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Payment code"}}}]},"IndodanaPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Indodana payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"FinpayMoneyPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Finpay Money payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"JeniusPayPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Jenius Pay payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"LinkAjaAppLinkPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for LinkAja App Link payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"LinkAjaWebPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for LinkAja Web payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"OVOPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for OVO payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"ShopeePayPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for ShopeePay payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"VirgoPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Virgo payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"BSecurePaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for BSecure payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"OctoClicksPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Octo Clicks payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"PermataNetPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for PermataNet payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"KredivoPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for Kredivo payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]},"ShopeePaylaterPaymentResponse":{"allOf":[{"$ref":"#/components/schemas/StandardResponse"},{"type":"object","properties":{"redirecturl":{"type":"string","description":"Redirect URL for ShopeePay Later payment"},"expiryLink":{"type":"string","description":"Expiry date for payment link"},"paymentCode":{"type":"string","description":"Generated payment code"}}}]}}},"paths":{"/pg/payment/card/initiate":{"post":{"tags":["Payment Initiation"],"summary":"Initiate Payment","description":"Universal payment initiation endpoint used by multiple payment methods.\nThe payment method is determined by the sourceOfFunds.type field.\n\nSupported payment types:\n- finpaycode: Finpay Payment Code\n- dana: DANA E-Money\n- finpaymoney: Finpay Money\n- jenius: Jenius Pay\n- linkajaapplink: LinkAja App Link\n- linkajaweb: LinkAja Web\n- ovo: OVO E-Money\n- shopeepay: ShopeePay E-Money\n- virgo: Virgo E-Money\n- qris: QRIS Payment\n- cc: Credit Card\n- bcaklikpay: BCA KlikPay\n- bsecure: BSecure\n- octoclicks: Octo Clicks\n- permatanet: PermataNet\n- kredivo: Kredivo Paylater\n- indodana: Indodana Paylater\n- shopeepaylater: ShopeePay Later\n","operationId":"initiatePayment","requestBody":{"required":true,"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/FinpayPaycodeRequest"},{"$ref":"#/components/schemas/DANAPaymentRequest"},{"$ref":"#/components/schemas/QRISPaymentRequest"},{"$ref":"#/components/schemas/CardPaymentRequest"},{"$ref":"#/components/schemas/BCAKlikPayPaymentRequest"},{"$ref":"#/components/schemas/IndodanaPaymentRequest"},{"$ref":"#/components/schemas/FinpayMoneyPaymentRequest"},{"$ref":"#/components/schemas/JeniusPayPaymentRequest"},{"$ref":"#/components/schemas/LinkAjaAppLinkPaymentRequest"},{"$ref":"#/components/schemas/LinkAjaWebPaymentRequest"},{"$ref":"#/components/schemas/OVOPaymentRequest"},{"$ref":"#/components/schemas/ShopeePayPaymentRequest"},{"$ref":"#/components/schemas/VirgoPaymentRequest"},{"$ref":"#/components/schemas/BSecurePaymentRequest"},{"$ref":"#/components/schemas/OctoClicksPaymentRequest"},{"$ref":"#/components/schemas/PermataNetPaymentRequest"},{"$ref":"#/components/schemas/KredivoPaymentRequest"},{"$ref":"#/components/schemas/ShopeePaylaterPaymentRequest"}],"discriminator":{"propertyName":"sourceOfFunds","mapping":{"finpaycode":"#/components/schemas/FinpayPaycodeRequest","dana":"#/components/schemas/DANAPaymentRequest","qris":"#/components/schemas/QRISPaymentRequest","cc":"#/components/schemas/CardPaymentRequest","bcaklikpay":"#/components/schemas/BCAKlikPayPaymentRequest","indodana":"#/components/schemas/IndodanaPaymentRequest","finpaymoney":"#/components/schemas/FinpayMoneyPaymentRequest","jenius":"#/components/schemas/JeniusPayPaymentRequest","linkajaapplink":"#/components/schemas/LinkAjaAppLinkPaymentRequest","linkajaweb":"#/components/schemas/LinkAjaWebPaymentRequest","ovo":"#/components/schemas/OVOPaymentRequest","shopeepay":"#/components/schemas/ShopeePayPaymentRequest","virgo":"#/components/schemas/VirgoPaymentRequest","bsecure":"#/components/schemas/BSecurePaymentRequest","octoclicks":"#/components/schemas/OctoClicksPaymentRequest","permatanet":"#/components/schemas/PermataNetPaymentRequest","kredivo":"#/components/schemas/KredivoPaymentRequest","shopeepaylater":"#/components/schemas/ShopeePaylaterPaymentRequest"}}}}}},"responses":{"200":{"description":"Payment initiated successfully","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/FinpayPaycodeResponse"},{"$ref":"#/components/schemas/DANAPaymentResponse"},{"$ref":"#/components/schemas/QRISPaymentResponse"},{"$ref":"#/components/schemas/CardPaymentResponse"},{"$ref":"#/components/schemas/BCAKlikPayPaymentResponse"},{"$ref":"#/components/schemas/IndodanaPaymentResponse"},{"$ref":"#/components/schemas/FinpayMoneyPaymentResponse"},{"$ref":"#/components/schemas/JeniusPayPaymentResponse"},{"$ref":"#/components/schemas/LinkAjaAppLinkPaymentResponse"},{"$ref":"#/components/schemas/LinkAjaWebPaymentResponse"},{"$ref":"#/components/schemas/OVOPaymentResponse"},{"$ref":"#/components/schemas/ShopeePayPaymentResponse"},{"$ref":"#/components/schemas/VirgoPaymentResponse"},{"$ref":"#/components/schemas/BSecurePaymentResponse"},{"$ref":"#/components/schemas/OctoClicksPaymentResponse"},{"$ref":"#/components/schemas/PermataNetPaymentResponse"},{"$ref":"#/components/schemas/KredivoPaymentResponse"},{"$ref":"#/components/schemas/ShopeePaylaterPaymentResponse"}]}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-pg-rest-api/payment-initiation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
